{flake, ...}: let
  inherit (flake.config.system.device) printer0 printer1;
  geneticPPD = "drv:///sample.drv/generic.ppd";
  pageSize = "Letter";
in {
  hardware.printers = {
    ensurePrinters = [
      {
        name = printer0.label;
        location = "Downstairs";
        deviceUri = "https://${printer0.ip.address0}";
        model = geneticPPD;
        ppdOptions = {
          PageSize = pageSize;
        };
      }
      {
        name = printer1.label;
        location = "Upstairs";
        deviceUri = "https://${printer1.ip.address0}";
        model = geneticPPD;
        ppdOptions = {
          PageSize = pageSize;
        };
      }
    ];
    ensureDefaultPrinter = printer1.label;
  };

  networking = {
    firewall = {
      allowedTCPPorts = [
        631
      ];
    };
  };
}
